#ifndef IO_S2P_H
#define IO_S2P_H IO_S2P_H

#include <cstdint>
#include <abmt/blob.h>
#include <abmt/io/buffer.h>
#include <abmt/io/protocols/s2p.h>

namespace io{

//@node: auto
struct s2p_encode{
    abmt::blob_shared in_blob;
    abmt::blob_shared out_stream;
    uint8_t param_id = 100;
    
    abmt::io::s2p s2p;
    abmt::io::buffer buffer;
    
    void init();
    void tick();
    
};

//@node: auto
struct s2p_decode{
    abmt::blob_shared in_stream;
    abmt::blob_shared out_blob;
    uint8_t param_id = 100;
    
    abmt::io::s2p s2p;
    abmt::io::buffer buffer;
    
    void init();
    void tick();
};

} // namespace io

#endif // IO_S2P_H
