#ifndef IO_TCP_H
#define IO_TCP_H IO_TCP_H

#include <string>
#include <cstdint>
#include <abmt/blob.h>
#include <abmt/io/eio.h>

namespace io{

//@node: auto
//you can also test with "$ nc localhost 12345"
struct tcp_server{
    abmt::blob_shared in_snd_to_all;
    abmt::blob_shared out;
    std::string param_target = "localhost";
    uint16_t param_port = 12345;
    
    abmt::io::event_list lst;
    abmt::io::tcp_server_ptr server;
    std::vector<abmt::io::tcp_ptr> connections;
    
    void init();
    void tick();
};

//@node: auto
struct tcp_client{
    abmt::blob_shared in;
    abmt::blob_shared out;
    std::string param_target = "localhost";
    uint16_t param_port = 12345;
    
    abmt::io::event_list lst;
    abmt::io::tcp_ptr con;
    abmt::io::timer reconnect_timer = {lst,1000};
    
    void init();
    void tick();
    void connect();
};

} // namespace io

#endif // IO_TCP_H
